type Derivation<T> = (previous: T) => T;
type Accessor<T> = () => T;
type Setter<T> = (value: T) => void;
type _Signal<T> = {
    get: Accessor<T>;
    set: Setter<T>;
};
type Signal<T> = [Accessor<T>, Setter<T>];
type Subscriber = {
    derived: _Signal<any> | null;
    execute: () => void;
};

export type { Accessor, Derivation, Setter, Signal, Subscriber, _Signal };
